CustomerService/CustomerService/Controllers/StatsController.cs
using Core.Enums;
using Core.Utils.Enums;
using Core.Utils.Json;
using CustomerService.Web.ViewModels.Stats;
using Services.Implementations.ReportService.Reports.RequestsReport;
using Services.Implementations.ReportService.Reports.UsersReport;
using Services.Interfaces.QueueService;
using Services.Interfaces.Reports;
using System;
using System.Linq;
using System.Threading.Tasks;
using System.Web.Mvc;

namespace CustomerService.Web.Controllers
{
    [Authorize(Roles = Core.Constants.RoleNames.Administrator)]
    [RoutePrefix("stats")]
    public class StatsController : Controller
    {
        private readonly IReportService _reportService;
        private readonly IQueueService _queueService;

        public StatsController(IReportService reportService, IQueueService queueService)
        {
            _reportService = reportService;
            _queueService = queueService;
        }

        [Route("")]
        [Route("Index")]
        public async Task<ActionResult> Index()
        {

            // Compromise approach
            // It is necessary to take filters from the front
            // But since there is no such requirement, filters are set directly in the code

            var requestReportFilter = new RequestReportFilter()
            {
                Since = (DateTime?)null,
                Until = (DateTime?)null,
                Count = 20,
            };

            var usersReportFilter = new UsersReportFilter()
            {
                UserTypes = new EnumList<UserType>()
                    .Where(t => t.Value != (int)UserType.Customer)
                    .Select(t => t.Value).ToList(),
            };

            var viewModel = new StatsViewModel()
            {
                ViewName = "Customer Service Statistics",
                Requests = await _reportService.GetRequestsReportAsync(requestReportFilter),
                Users = await _reportService.GetUsersReportAsync(usersReportFilter),
                QueueLength = _queueService.Length
            };

            return View("~/Views/Stats/Index.cshtml", viewModel);
        }

        [Route("update")]
        [HttpGet]
        public async Task<ActionResult> UpdateIndex()
        {
            // Compromise approach
            // It is necessary to take filters from the front
            // But since there is no such requirement, filters are set directly in the code

            var requestReportFilter = new RequestReportFilter()
            {
                Since = (DateTime?)null,
                Until = (DateTime?)null,
                Count = 20,
            };

            var usersReportFilter = new UsersReportFilter()
            {
                UserTypes = new EnumList<UserType>()
                    .Where(t => t.Value != (int)UserType.Customer)
                    .Select(t => t.Value).ToList(),
            };

            var viewModel = new StatsViewModel()
            {
                ViewName = "Customer Service Statistics",
                Requests = await _reportService.GetRequestsReportAsync(requestReportFilter),
                Users = await _reportService.GetUsersReportAsync(usersReportFilter),
                QueueLength = _queueService.Length
            };

            var result = new JsonNetResult(viewModel, JsonRequestBehavior.AllowGet);

            return result;
        }
    }
}

CustomerService/CustomerService/Controllers/UsersController.cs
using Core.Utils.Json;
using CustomerService.Web.ViewModels.Users;
using Services.Dtos;
using Services.Interfaces.UserService;
using System;
using System.Collections.ObjectModel;
using System.Linq;
using System.Web.Mvc;
using IMapper = AutoMapper.IMapper;

namespace CustomerService.Web.Controllers
{
    [RoutePrefix("users")]
    [Authorize(Roles = Core.Constants.RoleNames.Administrator)]
    public class UsersController : Controller
    {
        private readonly IUserService _userService;
        private readonly IMapper _mapper;
        private readonly int _adminRoleId;
        private readonly int _apiRoleId;

        public UsersController(IUserService userService, IMapper mapper)
        {
            _userService = userService;
            _mapper = mapper;

            var roles = _userService.GetRoles();
            _adminRoleId = roles.FirstOrDefault(r => r.Name == Core.Constants.RoleNames.Administrator)?.Id ?? 0;
            _apiRoleId = roles.FirstOrDefault(r => r.Name == Core.Constants.RoleNames.Api)?.Id ?? 0;

        }

        [Route("")]
        [Route("Index")]
        public ActionResult Index()
        {
            var users = _userService.GetUsers().ToList();

            var userList = new Collection<UserForListDto>();

            users.ForEach(user =>
            {
                var userDto = _mapper.Map<UserForListDto>(user);
                userDto.IsAdmin = user.Roles.Select(r => r.RoleId).Contains(_adminRoleId);
                userDto.IsApiUser = user.Roles.Select(r => r.RoleId).Contains(_apiRoleId);

                userList.Add(userDto);
            });


            var viewModel = new UsersViewModel
            {
                ViewName = "Users Management",
                UserTypes = _userService.GetUserTypes(),
                UserStatuses = _userService.GetUserStatuses(),
                Users = userList
            };

            return View("~/Views/Users/Index.cshtml", viewModel);
        }

        [HttpPost]
        [Route("create")]
        public ActionResult Create(UserForCreateDto request)
        {
            try
            {
                if (string.IsNullOrWhiteSpace(request.Email) || string.IsNullOrWhiteSpace(request.Password))
                    throw new ArgumentException("User or password can not be empty");

                var createdUser = _userService.CreateUser(request);
                var userForReturn = _mapper.Map<UserForListDto>(createdUser);
                userForReturn.IsAdmin = createdUser.Roles.Select(r => r.RoleId).Contains(_adminRoleId);
                userForReturn.IsApiUser = createdUser.Roles.Select(r => r.RoleId).Contains(_apiRoleId);


                var result = new JsonNetResult(userForReturn);
                return result;

            }
            catch (Exception ex)
            {
                return new HttpStatusCodeResult(500, ex.Message);
            }

        }

        [HttpPost]
        [Route("delete")]
        public ActionResult Delete(int userId)
        {
            try
            {
                return _userService.DeleteUser(userId) ? new HttpStatusCodeResult(200, "User successfully deleted") : new HttpStatusCodeResult(500, "Could not delete user");
            }
            catch (Exception ex)
            {
                return new HttpStatusCodeResult(500, ex.Message);
            }

        }

        [HttpPost]
        [Route("changeApiKey")]
        public ActionResult ChangeApiKey(int userId)
        {
            try
            {
                var result = _userService.ChangeApiKey(userId);
                return  new JsonNetResult(result);
            }
            catch (Exception ex)
            {
                return new HttpStatusCodeResult(500, ex.Message);
            }

        }
    }
}

CustomerService/CustomerService/Views/Shared/_Layout.cshtml
@using Core
@using Newtonsoft.Json;
@using Newtonsoft.Json.Serialization

@model CustomerService.Web.ViewModels.BaseViewModel

<!DOCTYPE html>
<html lang="en" ng-app="CustomerServiceApp">

<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>@ViewBag.Title - Customer Service</title>

    @Styles.Render($"~/Content/{Constants.WebNames.CssBundleName}")
    @Scripts.Render($"~/bundles/{Constants.WebNames.ModernizrBundleName}")

</head>

<body>

<nav class="navbar navbar-inverse navbar-fixed-top">
    <div class="container-fluid">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            @Html.ActionLink(@Core.Constants.Application.Name, "Index", "Home", new {area = ""}, new {@class = "navbar-brand"})
        </div>

        <div class="navbar-collapse collapse">
            <ul class="nav navbar-nav">

            </ul>

            @if (Request.IsAuthenticated)
            {

                using (Html.BeginForm("LogOff", "Account", FormMethod.Post, new {id = "logoutForm", @class = "navbar-right"}))
                {
                    @Html.AntiForgeryToken()

                    <ul class="nav navbar-nav navbar-right" style="margin-right: 15px;">
                        <li>
                            @Html.ActionLink("Hello, " + Model.UserName + "!", "Index", "Manage", routeValues: null, htmlAttributes: new {title = "Manage"})
                        </li>
                        <li>
                            <a href="javascript:document.getElementById('logoutForm').submit()">Log off</a>
                        </li>
                    </ul>
                }
            }

        </div>

    </div>
</nav>

<div class="site-middle clearfix">
    @if (Request.IsAuthenticated)
    {
        <aside class="sidebar">
            <nav class="menu-left">
                <ul>
                    @if (Model.IsAdmin)
                    {
                        <li>
                            <a href="@Url.Action("Index", "Users")">
                                <i class="fa fa-users"></i>
                                <span class="menu-title">
                                    Users
                                </span>
                            </a>
                        </li>
                    }
                    <li>
                        <a href="@Url.Action("Index", "Stats")">
                            <i class="fa fa-pie-chart"></i>
                            <span class="menu-title">
                                Statistics
                            </span>
                        </a>
                    </li>
                </ul>
            </nav>

        </aside>
    }


    <main class="site-content">
        <div class="entry">
            <div class="content-body">
                @RenderBody()
            </div>
        </div>
    </main>

</div>

    <footer>
        <p>&copy; @DateTime.Now.Year - @Core.Constants.Application.Name</p>
    </footer>

    @Scripts.Render($"~/bundles/{Constants.WebNames.JQueryBundleName}")
    @Scripts.Render($"~/bundles/{Constants.WebNames.BootstrapJsBundleName}")
    @Scripts.Render($"~/bundles/{Constants.WebNames.AngularJsBundleName}")
    @Scripts.Render($"~/bundles/{Constants.WebNames.Toastr}")
    @Scripts.Render($"~/bundles/{Constants.WebNames.MainAppJsBundleName}")
    @RenderSection("scripts", required: false)

    <script type="text/javascript">
        angular.module('CustomerServiceApp').value('serverModel', @Html.Raw(JsonConvert.SerializeObject(Model, new JsonSerializerSettings(){ContractResolver = new CamelCasePropertyNamesContractResolver()})));
    </script>

</body>
</html>